<?php 
namespace Concrete\Package\CcOptinFree\Controllers;

use Concrete\Core\Asset\AssetList;
use Concrete\Core\Http\ResponseAssetGroup;
use Concrete\Core\Page\Controller\DashboardPageController;

use Concrete\Package\CcOptinFree\CcOptin;

abstract class CcOptinConcreteController extends DashboardPageController implements CcOptinIController
{
	/**
	* Quick add of asset
	*/
	protected function addAndRequireAsset($type, $path, $usePackage = true) {
		$al = AssetList::getInstance();

		if(!$al->getAsset($type, $path))
			$al->register($type, $path, $path, array(), $usePackage ? CcOptin::package() : null);

		ResponseAssetGroup::get()->requireAsset($type, $path);
	}

	// ===== IController implementation =====

	public function outputJson($data) {
		CcOptinBaseController::outputJson($data);
	}

	public function outputJsonSuccess($text = true, $extraParams = null) {
		CcOptinBaseController::outputJsonSuccess($text, $extraParams);
	}

	public function outputJsonError($text = false, $extraParams = null) {
		CcOptinBaseController::outputJsonError($text, $extraParams);
	}

	private $security;

	public function security() { 
		if(!$this->security) $this->security = new CcOptinSecurity();
		return $this->security;
	}	

	protected function idList($array) {
		return CcOptinBaseController::idList($array);
	}
}
