<?php 
namespace Concrete\Package\CcOptinFree\Models;

use Loader;
use Page;

class CcOptinCampaign extends CcOptinModel
{
	const Table = 'cc_optin_campaigns';
	const LinkTable = 'cc_optin_campaigns_pages';

	public static $Rules = array(
		1 => 'afterSeconds',
		2 => 'showScroll',
		4 => 'hideScroll',
		8 => 'showAfterVisits',
		16 => 'hideAfterVisits',
		32 => 'exitIntention',
	);

	public static $SubmitActions = array(
		1 => 'redirect',
		2 => 'displayMessage',
		4 => 'sendEmail',
		8 => 'closeAfter'
	);

	public $_table = self::Table;

	///// Follow the structure of db.xml /////

	public $id;

	public $typeID;
	public $typeClass;

	public $designID;
	public $designClass;

	public $active;
	public $deleted;

	public $tracker; // uniqid() for every campaign, cookie tracker.

	public $name;
	public $start;
	public $end;
	public $subpages;

	// See static Rules array for mappings to int.
	public $rules;
	public $rule_afterSeconds;
	public $rule_showScroll;
	public $rule_hideScroll;
	public $rule_showAfterVisits;
	public $rule_hideAfterVisits;
	public $rule_exitIntention;

	// See static SubmitActions array for mappings to int.
	public $submitActions;
	public $sa_redirect;
	public $sa_displayMessage;
	public $sa_sendEmail;
	public $sa_closeAfter;

	public function __construct() {
		parent::__construct();
		$this->subpages = 0;
		$this->rules = 0;
		$this->submitActions = 0;
	} 

	public function rulesArray($includeData = true) {
		return CcOptinModel::createBitArray(self::$Rules, $this->rules, 'rule', $includeData ? $this : null);
	}

	public function submitActionsArray($includeData = true) {
		$array = CcOptinModel::createBitArray(self::$SubmitActions, $this->submitActions, 'sa', $includeData ? $this : null);

		if($array['redirect']) unset($array['redirect']);

		return $array;
	}

	public function templateHandle() {
		if(!$this->designID) return null;
		
		$designType = __NAMESPACE__ . '\\' . CcOptinDesign::$classMap[$this->designClass];
		$table = $designType::Table;

		$SQL = "SELECT templateHandle FROM $table WHERE id = ?";
		return Loader::db()->getOne($SQL, array($this->designID));
	}

	public function load($SQL = null, $bindarr = false, $lock = false) {

		return parent::load($SQL, $bindarr, $lock);
	}
}