<?php 
namespace Concrete\Package\CcOptinFree\Models;

use View;
use Concrete\Package\CcOptinFree\CcOptin;

abstract class CcOptinDesign extends CcOptinModel
{
	public static $classMap = array(1 => "CcOptinEmailDesign", 2 => "CcOptinCustomDesign");

	///// Common fields /////

	public $id;

	// Keeping track of previously created designs for a campaign, 
	// so they can be switched back to.
	public $campaignID; 

	// Handle for the /templates folder
	public $templateHandle;

	///// End common fields /////

	public function content($params = null) {
		// Test for parent handle that will be used in view.php if exists
		$template = CcOptinTemplate::get($this->templateHandle);

		if(!is_array($params)) $params = array();
		$params['model'] = $this;

		// TODO: Cache?
		$path = '../templates/' . ($template->parentHandle ? $template->parentHandle : $this->templateHandle) . '/view';
		ob_start();
		View::element($path, $params, CC_OPTIN);
		return ob_get_clean();
	}

	/**
	* Webserver path.
	*/
	public function path($append = '') {
		return CcOptin::path($this->localPath($append));
	}

	/**
	* Path within the package.
	*/
	public function localPath($append = '') {
		return 'templates/' . $this->templateHandle . '/' . $append;
	}

	/**
	* Validate fields against a CcOptinVal
	*/
	abstract public function validate($val);

	/**
	* Test if design has no content, to determine if it should be displayed.
	*/
	abstract public function isEmpty();
}
