<?php 
namespace Concrete\Package\CcOptinFree\Models;

use Loader;
use Concrete\Core\Legacy\Model;

abstract class CcOptinModel extends Model
{
	public static function create($int, $id = null, $params = null) { 
		$class = __NAMESPACE__ . '\\' . static::$classMap[$int];
		$o = new $class;
		
		if(intval($id)) 
			$o->load('id = ?', array($id));
		else if(is_string($id))
			$o->load($id, $params ? $params : array());

		return $o;
	}

	// array(int => "ClassName", ...)
	protected static $classMap;

	public function toJson() {
		$json  = Loader::helper('json');
		$output = array();

		foreach (func_get_args() as $field)
			$output[$field] = $this->$field;

		return $json->encode($output);
	}

	public function createBitArray($array, $field, $prefix, $dataObject = null) {
		$output = array();
		$i = 1;
		$limit = max(array_keys($array));

		// Test the bit of the rule
		while($i <= $limit) {
			if($field & $i) {
				$key = $array[$i];
				$var = $prefix . '_' . $key;

				$output[$key] = $dataObject ? $dataObject->$var : true;
			}
			$i *= 2; // $i <<= 2; Go ahead, make my day...
		}
		
		return $output;
	}

	///// Windows compatibilily fix for lastInsertId /////

	public function Replace() {
		$db = Loader::db();
		$data = array();

		$primaryKeys = $this->getPrimaryKeys();

		foreach($this as $key => $value) {
			if (!in_array($key, array('_table'))) {
				$data[$key] = $value;
			}
		}

		$columnName = $this->getAutoIncrementColumnName();
		$db->Replace($this->_table, $data, $primaryKeys);
		$this->setAutoincrementColumn($columnName);
		return 1;
	}

	protected function getAutoIncrementColumnName() {
		$db = Loader::db();
		$sm = $db->getSchemaManager();
		$details = $sm->listTableDetails($this->_table);
		foreach($details->getColumns() as $name => $column) {
			if($column->getAutoincrement()) {
				return $name;
			}
		}
		return null;
	}
	
	protected function setAutoIncrementColumn($name) {
		if(empty($name)) {
			return;
		}

		if(property_exists($this, $name) && empty($this->$name)) {
			$db = Loader::db();
			$this->$name = $db->lastInsertId();
		}
	}

	public function Insert() {
		$db = Loader::db();
		$data = array();

		foreach($this as $key => $value) {
			if (!in_array($key, array('_table'))) {
				$data[$key] = $value;
			}
		}

		$columnName = $this->getAutoIncrementColumnName();
		$db->insert($this->_table, $data);
		$this->setAutoincrementColumn($columnName);
	}

	//////////////////////////////////////////////////////
}
